unit ConvMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Wave, Law, Menus, MPlayer;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Exit1: TMenuItem;
    Open1: TMenuItem;
    Open2: TMenuItem;
    Wav2Law: TMenuItem;
    Law2Wave: TMenuItem;
    Test1: TMenuItem;
    Build1: TMenuItem;
    Wave1: TMenuItem;
    Law1: TMenuItem;
    procedure Open2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Wave2LawClick(Sender: TObject);
    procedure Law2WaveClick(Sender: TObject);
    procedure Test1Click(Sender: TObject);
    procedure Build1Click(Sender: TObject);
    procedure Law1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Law2WaveClick(Sender: TObject);
var
  outidx    : Cardinal;
  wert,
  lastwert  : SmallInt;
  wave      : TWave;
  inbuf     : array [1..2048] of Byte;
  outbuf    : array [1..4096] of SmallInt;
  i,
  readanz : Cardinal;
  filevar : File;
begin
  wave := TWave.Create;

  OpenDialog1.FileName := '*.law';

  if OpenDialog1.Execute then Begin
    AssignFile (filevar,OpenDialog1.FileName);

    Reset (filevar,1);
    if (IOResult = 0) then begin

      wave.SetFormat (1,8000,Bit_16);
      wave.Build ('test.wav');

      lastwert := 0;
      repeat
        BlockRead (filevar,inbuf,SizeOf (inbuf),readanz);

        outidx := 1;
        for i:= 1 to readanz do begin
          wert := LawToInt (inbuf [i]);

          {
          outbuf [outidx] := lastwert + (wert - lastwert) div 2;
          outbuf [outidx + 1] := wert;
          Inc (outidx,2);
          }

          outbuf [outidx] := wert;
          Inc (outidx);

          lastwert := wert;
        end;

        wave.Write (outbuf,readanz);
      until (readanz = 0);

      wave.Close;
      CloseFile (filevar);
    end;
  end;

  wave.Destroy;
end;

procedure TForm1.Open2Click(Sender: TObject);
var
  wave    : TWave;
begin
  wave := TWave.Create;
  OpenDialog1.FileName := '*.wav';

  if OpenDialog1.Execute then Begin
    wave.Open (OpenDialog1.FileName);

    wave.Close;
  end;

  wave.Destroy;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Wave2LawClick(Sender: TObject);
var
  outidx    : Cardinal;
  wert,
  lastwert  : SmallInt;
  wave      : TWave;
  outbuf    : array [1..2048] of Byte;
  inbuf     : array [1..4096] of SmallInt;
  i,
  readanz : Cardinal;
  filevar : File;
begin
  wave := TWave.Create;

  OpenDialog1.FileName := '*.wav';

  if OpenDialog1.Execute then Begin
    if (wave.Open (OpenDialog1.FileName) = 0) then begin
      AssignFile (filevar,'test.law');

      Rewrite (filevar,1);
      if (IOResult = 0) then begin
        repeat
          readanz := wave.Read (inbuf,2048);

          if (readanz > 0) then begin
            for i:= 1 to readanz do
              outbuf [i] := IntToLaw (inbuf [i]);;

            BlockWrite (filevar,outbuf,readanz);
          end;
        until (readanz = 0);

        CloseFile (filevar);
      end;

      wave.Close;
    end;
  end;

  wave.Destroy;
end;

procedure TForm1.Test1Click(Sender: TObject);
var
  numstr : String [20];
  errpos : Cardinal;
  wert   : Integer;
begin
  numstr := InputBox ('Konvertierung Integer nach uLaw','Intwert','');
  if (Length (numstr) > 0) then begin
    Val (numstr,wert,errpos);

    if (errpos = 0) then
      MessageDLG (IntToHex (IntToLaw (wert), 2), mtInformation, [mbOK], 0);
  end;
end;

procedure TForm1.Build1Click(Sender: TObject);
var
  i       : Integer;
  j       : Cardinal;
  outbuf  : array [1..1024] of SmallInt;
  wave    : TWave;

begin
  wave := TWave.Create;

  wave.SetFormat (1,8000,Bit_16);
  wave.Build ('build.wav');

  i := -32000;
  repeat
    for j:=1 to 1024 do begin
      outbuf [j] := i;
      Inc (i);
    end;

    wave.Write (outbuf,1024);
  until i > 32000;

  wave.Close;
  wave.Destroy;
end;

procedure TForm1.Law1Click(Sender: TObject);
var
  outbuf : array [0..15] of byte;
  i,j,n : Cardinal;
  lawfile : File;
  res,res2 : Byte;
begin
  AssignFile (lawfile,'build.law');
  Rewrite (lawfile,1);
  if (IOResult = 0) then begin

    for i:=7 downto 0 do begin
      for j:=15 downto 0 do begin
        res := $80 + (i shl 4) + j;

        res2 := 0;

        for n:=0 to 7 do begin
          if (res and (1 shl n) <> 0) then
            res2 := res2 or ($80 shr n);
        end;

        outbuf [15 - j] := res2 xor $AA;
      end;

      BlockWrite (lawfile,outbuf,16);
    end;

    for i:=0 to 7 do begin
      for j:=0 to 15 do begin
        res := (i shl 4) + j;

        res2 := 0;
        
        for n:=0 to 7 do begin
          if ((res and (1 shl n)) <> 0) then
            res2 := res2 or ($80 shr n);
        end;

        outbuf [j] := res2 xor $AA;
      end;

      BlockWrite (lawfile,outbuf,16);
    end;

    CloseFile (lawfile);
  end;
end;

end.
