(****************************************************************************
*                                                                           *
*  Copyright 1996 bei Stefan Graf (CompuServe: 100736.2464)                 *
*                                                                           *
*****************************************************************************)
unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, ExtCtrls, Capi2Con, Capi2Typ, Capi2Han,Capi2Bas;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    Exit1: TMenuItem;
    Info1: TMenuItem;
    Test1: TMenuItem;
    Memo2: TMemo;
    Call1: TMenuItem;
    Digital: TMenuItem;
    Analog: TMenuItem;
    Disconnect1: TMenuItem;
    Send1: TMenuItem;
    Ein1: TMenuItem;
    Aus1: TMenuItem;
    testtxt1: TMenuItem;
    Select1: TMenuItem;
    OpenFileDialog: TOpenDialog;
    Anmelden1: TMenuItem;
    Abmelden1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    procedure Info1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Capi1Error(Sender: TObject; const CommandID, SubCommand, ErrorNumber: Cardinal);
    procedure Capi1Info(Sender: TObject; const Info: Cardinal; var InfoDaten: CapiParameterType);
    procedure Capi1MessageDump (Sender: TObject; const CommandID, SubCommand : Cardinal; var Daten: IndicationDatenType);
    procedure Capi1Connect(Sender: TObject);
    procedure Capi1Disconnect(Sender: TObject; const Grund : Cardinal);
    procedure Capi1DataConnect(Sender: TObject; const Kanal : BKanalType);
    procedure Capi1Receive(Sender: TObject; const Kanal : BKanalType; const Count: Cardinal);
    procedure DigitalClick(Sender: TObject);
    procedure AnalogClick(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    function Capi1Ring(Sender: TObject;
      const Service: TCapiService;
      const ServiceAdd : Cardinal;
      const CallFrom: TCallNumber;
      const CallTo: TCallNumber): Cardinal;
    procedure FormCreate(Sender: TObject);
    procedure Ein1Click(Sender: TObject);
    procedure Aus1Click(Sender: TObject);
    procedure testtxt1Click(Sender: TObject);
    procedure Select1Click(Sender: TObject);
    procedure DTMF1Click(Sender: TObject);
    procedure Anmelden1Click(Sender: TObject);
    procedure Abmelden1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    {$IFDEF Debug}
      LogFile : TextFile;
    {$ENDIF}

    DataKanal : BKanalType;
    recvflag : Boolean;
    recvfile : File;

  public
    Capi1 : TCapi20Handler;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Info1Click(Sender: TObject);
begin
  Memo1.Lines.Add (Capi1.GetHersteller + ' / ' + Capi1.GetVersion + ' / ' + Capi1.GetSerialNumber);

  Memo1.Lines.Add ('B-Kanle     : ' + IntToStr (Capi1.GetAnzahlBCannel (1)));
  Memo1.Lines.Add ('Optionen     : ' + IntToHex (Capi1.GetOptionen (1),8));
  Memo1.Lines.Add ('B1-Protokolle: ' + IntToHex (Capi1.GetSupportedB1Protokoll (1),8));
  Memo1.Lines.Add ('B2-Protokolle: ' + IntToHex (Capi1.GetSupportedB2Protokoll (1),8));
  Memo1.Lines.Add ('B3-Protokolle: ' + IntToHex (Capi1.GetSupportedB3Protokoll (1),8));
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Capi1.EnableListen ([]);

  Capi1.Destroy;

  Close;
end;

procedure TForm1.Capi1MessageDump (Sender: TObject; const CommandID, SubCommand : Cardinal; var Daten: IndicationDatenType);
var
  i    : Word;
  line : String;
begin
  line := Capi1.GetCommandStr (CommandID,SubCommand);

  if (SubCommand = CONF) then begin
    case CommandID of
      DATA_B3 : line := line + ' Block: ' + IntToStr (Daten.DataB3Conf.BlockNr);
    end;
  end else begin
    case CommandID of
      DATA_B3 : line := line + ' Block: ' + IntToStr (Daten.DataB3Ind.BlockNr) + ' Size: '
                        + IntToStr (Daten.DataB3Ind.DataSize);
      DISCONNECT    : line := line + ' 0x' + IntToHex (Daten.DisconnectInd.Reason,4);

      INFO : begin
        line := 'Info (' + IntToHex (Daten.InfoInd.InfoNr,4) + ') ';
        if ((Daten.InfoInd.InfoNr and $8000) = 0) then begin
          for i := 1 to Length (Daten.InfoInd.Info) do
            line := line + ' ' + IntToHex (Ord (Daten.InfoInd.Info [i]),2);
        end;
      end;

      CONNECT : begin
        line := 'Call from ' + Copy (Daten.ConnectInd.CalledNumber,2,255) + ':' + Daten.ConnectInd.CalledSubAdr;
        line := line + ' / ' + Copy (Daten.ConnectInd.CallingNumber,2,255) + ':' + Daten.ConnectInd.CallingSubAdr;
        Memo1.Lines.Add (line);

        line := 'Service : ' + IntToStr (Daten.ConnectInd.CIPValue) + ' / Bearer Capability:';
        for i:= 1 to Length (Daten.ConnectInd.BC) do
          line := line + ' 0x' + IntToHex (Ord (Daten.ConnectInd.BC [i]),2);
      end;
    end;
  end;

  line := Copy (line,1,60);
  Memo1.Lines.Add (line);
end;

procedure TForm1.Capi1Error(Sender: TObject; const CommandID, SubCommand, ErrorNumber: Cardinal);
begin
  MessageDLG (Capi1.GetCommandStr (CommandID,SubCommand) + ' : ' + Capi1.GetErrorStr (ErrorNumber), mtWarning, [mbOK], 0);
end;

function TForm1.Capi1Ring(Sender: TObject;
                          const Service : TCapiService;
                          const ServiceAdd : Cardinal;
                          const CallFrom: TCallNumber;
                          const CallTo: TCallNumber) : Cardinal;
const
  ServiceStr : array [0..7] of String [20] = ('','ANALOG_TELEPHONY','DIGITAL_TELEPHONY',
                                              'FAX3','FAX4','DATA_64K','DATA_56K','UNKNOWN');

var line : String;
begin
  line := 'Call from ' + Copy (CallFrom,3,255) + ' to ' + Copy (CallTo,2,255);
  line := line + ' : Service : ' + ServiceStr [Ord (Service)] + ' (' + IntToStr (Ord (Service)) + ')' ;

  Memo2.Lines.Add (line);

  if (Service = DATA_64K) then
    Capi1Ring := ACCEPT_CALL
  else if (Service = ANALOG_TELEPHONY) or (Service = DIGITAL_TELEPHONY) then begin
    Capi1.B1Protokol := TRANS_64K;
    Capi1.B2Protokol := BITTRANS;
    Capi1.B3Protokol := B3_TRANSPARENT;

    Capi1Ring := IGNORE_CALL;
  end else Capi1Ring := IGNORE_CALL;
end;

procedure TForm1.Capi1Info(Sender: TObject; const Info: Cardinal; var InfoDaten: CapiParameterType);
var line : String;
begin
  line := 'Info (' + IntToHex (Info,4) + ') ';
  if ((Info and $8000) = 0) then begin
    case (Info and $00FF) of
     $40 : begin
             line := line + 'Gebhren ';
           end;
     $29 : begin
             line := line + 'Datum : ' + IntToStr (Ord (InfoDaten [3])) + '.';
             line := line + IntToStr (Ord (InfoDaten [2])) + '.';
             line := line + '19' + IntToStr (Ord (InfoDaten [1]));
             line := line + ' ' + IntToStr (Ord (InfoDaten [4]));
             line := line + ':' + IntToStr (Ord (InfoDaten [5]));
           end;
    end;
  end else begin
  end;

  line := Copy (line,1,60);
  Memo2.Lines.Add (line);
end;

procedure TForm1.Capi1Connect(Sender: TObject);
begin
  {$IFDEF DEBUG}
    AssignFile (LogFile,'CAPI.LOG');
    Rewrite (LogFile);
  {$ENDIF}

  {Die weitere Rufannahme verhindern}
  Capi1.EnableListen ([]);

  {Es soll automatisch eine B-Kanal-Verbindung erzeugt werden.}
  Capi1.AutoBConnect := true;

  {Capi1.OpenBConnect;}
end;

procedure TForm1.Capi1DataConnect(Sender: TObject; const Kanal : BKanalType);
begin
  recvflag := False;
  DataKanal := Kanal;
end;

procedure TForm1.Capi1Receive(Sender: TObject; const Kanal : BKanalType; const Count: Cardinal);
var
  i,
  size,
  writeanz : Cardinal;
  ch       : Char;
  line     : String;
  fname    : TFileName;
  buf      : Array [0..2048] of Char;

begin
  Memo2.Lines.Add ('Received ' + IntToStr (Count) + ' Bytes');

  Capi1.Read (Kanal,buf,Count);

  {$IFDEF Debug}
    Write (LogFile,Count,' : ');
    if (IOResult <> 0) then;
    if (Count > 40) then
      size := 40
    else size := Count;
    for i:=0 To (size - 1) do begin
      Write (LogFile,IntToHex (Ord (buf [i]),2),' ');
      if (IOResult <> 0) then;
    end;
    WriteLn (LogFile);
    if (IOResult <> 0) then;
    Flush (LogFile);
  {$ENDIF}

  if (recvflag) then begin
    if (buf [0] = #255) and (buf [1] = #255) then begin
       CloseFile (recvfile);
       recvflag := false;
       line := 'Close File';
    end else begin
      writeanz := Count - 2;
      line := 'Write ' + IntToStr (writeanz) + ' Bytes : ';
      BlockWrite (recvfile,buf [2],writeanz);

      if (IOResult = 0) then
        line := line + ' Ok'
      else line := line + ' Fehler';
      line := 'Write ' + IntToStr (Count) + ' Bytes : ';
    end;

    Memo2.Lines.Add (line);
  end else begin
    if (Capi1.ConnectedService = DATA_64K) then begin
      i:=0;

      repeat
        if (buf [i] = #255) then begin
          Inc (i);

          if (buf [i] = #255) then begin
            Inc (i);

            Move (buf [i], fname, Ord (buf [i]) + 1);
            Inc (i,Ord (buf [i]) + 1);

            AssignFile (recvfile,fname);
            Rewrite (recvfile,1);
            if (IOResult = 0) then begin
              recvflag := true;
              i := Count + 1;
            end;
          end;
        end;

        if not (recvflag) then
          SendMessage (Memo2.Handle,WM_CHAR,Word (buf [i]),0)
        else Memo2.Lines.Add ('Receive file ' + Copy (fname,1,12));

        Inc (i);
      until (i >= (Count - 1));
    end;
  end;
end;

procedure TForm1.DigitalClick(Sender: TObject);
var numstr : String [20];
begin
  numstr := InputBox ('Telefonnummer','Rufnummer eingeben','');
  if (Length (numstr) > 0) then begin
    Capi1.Call (numstr,DATA_64K);
  end;
end;

procedure TForm1.AnalogClick(Sender: TObject);
var numstr : String [20];
begin
  numstr := InputBox ('Telefonnummer','Rufnummer eingeben','');
  if (Length (numstr) > 0) then begin
    Capi1.Call (numstr,ANALOG_TELEPHONY);
  end;
end;

procedure TForm1.Disconnect1Click(Sender: TObject);
begin
  Capi1.DisconnectLine (1);
end;

procedure TForm1.testtxt1Click(Sender: TObject);
var
  line    : String;
  filevar : TextFile;
begin
  AssignFile (filevar,'C:\autoexec.bat');

  Reset (filevar);

  while Not (Eof (filevar)) Do begin
    ReadLn (filevar,line);
    line := line + #13 + #10;

    Capi1.Write (DataKanal,line [1],Length (line));
  end;

  CloseFile (filevar);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
{$IFDEF CAPI_11}
  Capi1 := TCapiHandler.Create (Self);

  Capi1.OwnEAZ := EAZ_1;
  Capi1.Infos := [Gebuehren,DatumZeit,Display,UserToUser,DisconnectCause,Status];

  Capi1.OnError         := Capi1Error;
  Capi1.MessageDump     := Capi1MessageDump;
  Capi1.OnRing          := Capi1Ring;
  Capi1.OnDataConnect   := Capi1DataConnect;
  Capi1.OnReceive       := Capi1Receive;
  Capi1.OnInfo          := Capi1Info;
  Capi1.OnDisconnect    := Capi1Disconnect;
{$ELSE}
  Capi1 := TCapi20Handler.Create (Self);

  Capi1.Controller := 1;
  Capi1.OwnNumber  := '7246501';
  Capi1.Infos      := [Gebuehren,DatumZeit,Display,UserToUser,Facilities,DisconnectCause,RufStatus,CalledNumber];

  Capi1.OnError         := Capi1Error;
  Capi1.MessageDump     := Capi1MessageDump;
  Capi1.OnRing          := Capi1Ring;
  Capi1.OnConnect       := Capi1Connect;
  Capi1.OnBConnect      := Capi1DataConnect;
  Capi1.OnReceive       := Capi1Receive;
  Capi1.OnInfo          := Capi1Info;
  Capi1.OnDisconnect    := Capi1Disconnect;

{
  Capi1.OnSend          :=;
  Capi1.OnConnect       :=;
  Capi1.OnDataInfo      :=;
  Capi1.OnMessage       :=;
}
{$ENDIF}
end;

procedure TForm1.Ein1Click(Sender: TObject);
begin
  {$IFDEF CAPI_11}
    Capi1.EnableListen ([EAZ_1,EAZ_2],[AB_SERVICE,TELEPHONY, DATA_64k]);
  {$ELSE}
{    Capi1.EnableListen ([DIGITAL_TELEPHONY, ANALOG_TELEPHONY, DATA_64k]);}
    Capi1.EnableListen ([ALL]);
  {$ENDIF}
end;

procedure TForm1.Aus1Click(Sender: TObject);
begin
  {$IFDEF CAPI_11}
    Capi1.EnableListen ([],[]);
  {$ELSE}
    Capi1.EnableListen ([]);
  {$ENDIF}
end;

procedure TForm1.Select1Click(Sender: TObject);
type
  bufarray = array [1..8196] of char;
var
  filevar : File;
  fname   : TFileName;
  line    : String;
  time    : LongInt;
  i,
  anz,
  err,
  strpos,
  sendanz : Word;
  maxread,
  readanz : Cardinal;
  size    : LongInt;
  buf     : ^bufarray;
begin
  OpenFileDialog.FileName := '*.*';

  if OpenFileDialog.Execute then Begin
    AssignFile (filevar,OpenFileDialog.FileName);

    Reset (filevar,1);
    if (IOResult <> 0) Then
      MessageDLG ('Datei ' + OpenFileDialog.FileName + ' kann nicht geffnet werden', mtWarning, [mbOK], 0)
    else begin
      size:=FileSize (filevar);

      fname := OpenFileDialog.FileName;

      repeat
        strpos := Pos ('\',fname);
        if (strpos > 0) then
          Delete (fname,1,strpos);
      until (strpos = 0);

      line:=#255 + #0 + Chr (Length (fname)) + fname;
      Capi1.Write (DataKanal,line [1],Length (line));

      GetMem (buf,8196);

      time := GetTickCount;

      err := 0;

      while not eof (filevar) and (err = 0) do begin
        {$IFDEF CAPI_11}
          maxread := Capi1.BufferSize - 2;
        {$ELSE}
          maxread := Capi1.BDataBlockSize - 2;
        {$ENDIF}

        BlockRead (filevar,buf^[3],maxread,readanz);

        if (IOResult <> 0) then begin
          err := 1;
          MessageDLG ('Lesefehler in ' + OpenFileDialog.FileName, mtWarning, [mbOK], 0)
        end else begin
          Memo1.Lines.Add ('Send ' + IntToStr (readanz) + ' Bytes');

          if (readanz > 0) then begin
            buf^[1] := #255;
            buf^[2] := #3;

            if (Capi1.Write (DataKanal,buf^,readanz + 2) <> (readanz + 2)) then
              err := 2;
          end;
        end;
      end;

      time := GetTickCount - time;
      line := IntToStr (time) + ' ms / ';
      if (time <> 0) then
        line := line + IntToStr (1000 * size Div time)
      else line := line + '---';
      line:= line + ' Bytes/Sec';

      Memo2.Lines.Add (line);

      FreeMem (buf,8196);

      line:=#255 + #1;
      Capi1.Write (DataKanal,line [1],Length (line));

      CloseFile (filevar);
    end;
  end;
end;

procedure TForm1.Capi1Disconnect(Sender: TObject; const Grund: Cardinal);
begin
  if (recvflag) then
    CloseFile (recvfile);

  recvflag := false;

{$IFDEF Denug}
  CloseFile (LogFile);
{$ENDIF}
end;

procedure TForm1.DTMF1Click(Sender: TObject);
var req  : RequestDatenType;
begin
  {$IFDEF CAPI_20}
    FillChar (req,sizeof (req),0);

    req.FacilityReq.NCCI := DataKanal;
    req.FacilityReq.Selector := SelectorDTMF;
    req.FacilityReq.Parameter.Size := 2;
    req.FacilityReq.Parameter.FunctionCode := 1;

    Capi1.SendRequestMessage (FACILITY,req);
  {$ENDIF}
end;

procedure TForm1.Anmelden1Click(Sender: TObject);
begin
  Capi1.RegisterApplication;
end;

procedure TForm1.Abmelden1Click(Sender: TObject);
begin
  Capi1.ReleaseApplication;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Capi1.ReleaseApplication;
end;

end.
