{$I-}
unit Talkmain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, Capi2Bas, Capi2han, Capi2Con, Capi2Typ, Wave, Law, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Exit1: TMenuItem;
    Anrufbeantworter1: TMenuItem;
    Ein1: TMenuItem;
    Aus1: TMenuItem;
    AnruferDisplay: TMemo;
    CAPIDisplay: TMemo;
    CapiHandler: TCapi20Handler;
    ListBox1: TListBox;
    MsnNeu: TButton;
    MsnDel: TButton;

    {$IFDEF WIN32}
    function CapiHandlerRing(Sender: TObject;
      const Service: TCapiService; const AddService: Cardinal; const CallFrom,
      CallTo: TCallNumber): Cardinal;
    procedure Exit1Click(Sender: TObject);
    procedure Ein1Click(Sender: TObject);
    procedure Aus1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy (Sender: TObject);
    procedure CapiHandlerMessageDump(Sender: TObject; const CommandID,
      SubCommand: Cardinal; var Daten: IndicationDatenType);
    procedure CapiHandlerReceive(Sender: TObject; const NCCI:LongInt;
      const Count: Cardinal);
    procedure CapiHandlerBConnect(Sender: TObject; const NCCI: LongInt);
    procedure CapiHandlerBDisconnect(Sender: TObject; const NCCI: Longint;
    const Grund: Cardinal);
    procedure CapiHandlerDisconnect(Sender: TObject;
      const Grund: Cardinal);
    procedure CapiHandlerError(Sender: TObject; const CommandID,
      SubCommand, ErrorNumber: Cardinal);
    procedure ListBox1DblClick(Sender: TObject);
    procedure MsnNeuClick(Sender: TObject);
    procedure MsnDelClick(Sender: TObject);
    {$ELSE}
    {
        function CapiHandlerRing(Sender: TObject;
          const Service: TCapiService; const AddService: Word; const CallFrom,
          CallTo: TCallNumber): Word;
        procedure CapiHandlerDisconnect(Sender: TObject; const Grund: Word);
        procedure Exit1Click(Sender: TObject);
        procedure Ein1Click(Sender: TObject);
        procedure Aus1Click(Sender: TObject);
        procedure FormCreate(Sender: TObject);
        procedure CapiHandlerMessageDump(Sender: TObject; const CommandID,
          SubCommand: Word; var Daten: IndicationDatenType);
        procedure CapiHandlerReceive(Sender: TObject; const NCCI:LongInt;
          const Count: Word);
        procedure CapiHandlerBConnect(Sender: TObject; const NCCI: LongInt);
        procedure CapiHandlerBDisconnect(Sender: TObject; const NCCI : LongInt;
          const Grund: Word);
    procedure CapiHandlerError(Sender: TObject; const CommandID,
      SubCommand, ErrorNumber: Word);
      }
    {$ENDIF}
  private
    wave : TWave;
    abKanal : BKanalType;

    RufAnnahme : Boolean;
    AntwortFile : File;
    AntwortOpen : boolean;
    AntwortDauer : LongInt;

    function ReadConfig : Integer;
    function SaveConfig : Integer;

  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.CapiHandlerBConnect(Sender: TObject; const NCCI: LongInt);
var
  i       : Cardinal;
  readanz : Integer;
  inbuf   : array [1..2048] of SmallInt;
  outbuf  : array [1..4096] of Byte;

begin
  abKanal := NCCI;

  if (Wave.Open ('ansage.wav') = 0) then begin
    repeat
      readanz := Wave.Read (inbuf,CapiHandler.BDataBlockSize);

      if (readanz > 0) then begin
        for i:=1 to readanz do
          outbuf [i] := IntToLaw (inbuf [i]);

        CapiHandler.Write (abKanal, outbuf, readanz);
      end;
    until (readanz <= 0);

    Wave.Close;
  end;

  CapiHandler.Flush (abKanal);

  AntwortDauer := GetTickCount;

  AssignFile (AntwortFile,'antwort.law');
  Rewrite (AntwortFile,1);
  if (IOResult = 0) then AntwortOpen := true;
end;

function TForm1.CapiHandlerRing(Sender: TObject;
  const Service: TCapiService; const AddService: Cardinal; const CallFrom,
  CallTo: TCallNumber): Cardinal;

var
  i       : Cardinal;
  found   : Boolean;
  numstr  : String [26];
  line    : String;
  nowtime : TDateTime;

begin
  line := Copy (CallFrom,3,Length (CallFrom) - 2);
  line := line + ' fr ' + Copy (CallTo,2,Length (CallTo) - 1);

  AnruferDisplay.Lines.Add (line);

  if (Service <> ANALOG_TELEPHONY) and (Service <> DIGITAL_TELEPHONY) then
    CapiHandlerRing := IGNORE_CALL
  else begin
    i := 0;
    found := false;
    numstr := Copy (CallTo,2,Length (CallTo) - 1);

    while not (found) and (i < ListBox1.Items.Count) do begin
      if (ListBox1.Items [i] = numstr) then
        found := true
      else Inc (i);
    end;

    if not (found) then
      CapiHandlerRing := IGNORE_CALL
    else begin
      CapiHandler.EnableListen ([]);

      nowtime := Now;
      line := DateToStr (nowtime) + ' ' + TimeToStr (nowtime);
      line := line + ' : Anruf von ';
      if (Length (CallFrom) = 0) then
        line := line + 'unbekannt'
      else if (CallFrom [2] = #$A0) then
        line := line + 'anonym'
      else line := line + Copy (CallFrom,3,Length (CallFrom) - 2);

      line := line + ' fr ' + Copy (CallTo,2,Length (CallTo) - 1);

      AnruferDisplay.Lines.Add (line);

      CapiHandler.B1Protokol := TRANS_64K;
      CapiHandler.B2Protokol := BITTRANS;
      CapiHandler.B3Protokol := B3_TRANSPARENT;

      CapiHandlerRing := ACCEPT_CALL
    end;
  end;
end;

procedure TForm1.CapiHandlerReceive(Sender: TObject; const NCCI : LongInt; const Count: Cardinal);
var
  readanz : Cardinal;
  buf : array [0..4096] of char;
begin
  readanz := CapiHandler.Read (abKanal, buf,Count);

  if (AntwortOpen) then begin
{    LawToWav (buf,wavbuf,readanz,convanz);}

    BlockWrite (AntwortFile,buf,readanz);

    if (IOResult <> 0) then;
  end;
end;

procedure TForm1.CapiHandlerDisconnect(Sender: TObject; const Grund: Cardinal);
begin
  AntwortDauer := GetTickCount - AntwortDauer;
  AnruferDisplay.Lines.Add ('  Dauer: ' + IntToStr (AntwortDauer div 1000) + ' Sekunden');

  if RufAnnahme then
    CapiHandler.EnableListen ([ANALOG_TELEPHONY, DIGITAL_TELEPHONY]);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  if CapiHandler.ApplicationRegistered then
    CapiHandler.EnableListen ([]);

  Close;
end;

procedure TForm1.Ein1Click(Sender: TObject);
begin
  if not (CapiHandler.ApplicationRegistered) then
    MessageDLG ('CAPI nicht verfgbar', mtWarning, [mbOK], 0)
  else begin
    RufAnnahme := true;

    CapiHandler.EnableListen ([ANALOG_TELEPHONY, DIGITAL_TELEPHONY]);
  end;
end;

procedure TForm1.Aus1Click(Sender: TObject);
begin
  if not (CapiHandler.ApplicationRegistered) then
    MessageDLG ('CAPI nicht verfgbar', mtWarning, [mbOK], 0)
  else begin
    RufAnnahme := false;

    CapiHandler.EnableListen ([]);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Wave := TWave.Create;

  CapiHandler.BDataBlockSize := 2048;

  RufAnnahme := false;
  AntwortOpen := false;

  ListBox1.Items.Clear;
  ReadConfig;

  if CapiHandler.CapiAvailable and not (CapiHandler.ApplicationRegistered) then
    CapiHandler.RegisterApplication;
end;

procedure TForm1.CapiHandlerMessageDump(Sender: TObject; const CommandID,
  SubCommand: Cardinal; var Daten: IndicationDatenType);
begin
  if (CommandID <> DATA_B3) then
    CAPIDisplay.Lines.Add (CapiHandler.GetCommandStr (CommandID,SubCommand));
end;

procedure TForm1.CapiHandlerBDisconnect(Sender: TObject; const NCCI : LongInt; const Grund: Cardinal);
begin
  if (AntwortOpen) then
    CloseFile (AntwortFile);

  AntwortOpen := false;
end;

procedure TForm1.CapiHandlerError(Sender: TObject; const CommandID,
  SubCommand, ErrorNumber: Cardinal);
begin
  MessageDLG (CapiHandler.GetCommandStr (CommandID,SubCommand) + ' : ' +
    CapiHandler.GetErrorStr (ErrorNumber), mtWarning, [mbOK], 0);
end;

procedure TForm1.FormDestroy (Sender: TObject);
begin
  Wave.Destroy;
  
  if CapiHandler.ApplicationRegistered then
    CapiHandler.ReleaseApplication;
end;

function TForm1.ReadConfig : Integer;
var
  line    : String;
  auswahl : Cardinal;
  cfgfile : TextFile;
begin
  AssignFile (cfgfile,'anruf.ini');
  Reset (cfgfile);
  if (IOResult <> 0) then
    ReadConfig := -1
  else begin
    auswahl := 0;
    ListBox1.Items.Clear;

    while not (Eof (cfgfile)) do begin
      ReadLn (cfgfile,line);
      if (line [1] = '[') then begin
        if (Pos ('[LISTEN_MSN]',line) <> 0) then
          auswahl := 1;
      end else begin
        case auswahl of
          1 : ListBox1.Items.Add (line);
        end;
      end;
    end;

    CloseFile (cfgfile);

    ReadConfig := 0;
  end;
end;

function TForm1.SaveConfig : Integer;
var
  i       : Cardinal;
  cfgfile : TextFile;
begin
  AssignFile (cfgfile,'anruf.ini');
  Rewrite (cfgfile);
  if (IOResult <> 0) then
    SaveConfig := -1
  else begin
    WriteLn (cfgfile,'[LISTEN_MSN]');

    for i:=0 to (ListBox1.Items.Count - 1) do
      WriteLn (cfgfile,ListBox1.Items [i]);

    CloseFile (cfgfile);

    SaveConfig := 0;
  end;
end;
procedure TForm1.ListBox1DblClick(Sender: TObject);
var numstr : String [26];
begin
  if (ListBox1.ItemIndex <> -1) then begin
    numstr := InputBox ('Telefonnummer','Rufnummer ndern',ListBox1.Items [ListBox1.ItemIndex]);
    if (ListBox1.Items [ListBox1.ItemIndex] <> numstr) then begin
      ListBox1.Items [ListBox1.ItemIndex] := numstr;

      SaveConfig;
    end;
  end;
end;

procedure TForm1.MsnNeuClick(Sender: TObject);
var numstr : String [26];
begin
  numstr := InputBox ('Telefonnummer','Neue Rufnummer eingeben','');
  if (Length (numstr) > 0) then begin
    ListBox1.Items.Add (numstr);

    SaveConfig;
  end;
end;

procedure TForm1.MsnDelClick(Sender: TObject);
begin
  if (ListBox1.ItemIndex <> -1) then begin
    ListBox1.Items.Delete (ListBox1.ItemIndex);

    SaveConfig;
  end;
end;

end.
